import imp, os, sys

def update_from_dict(module,dict):
    for attr in dict.keys():
    	setattr(module,attr,dict[attr])
    	
def name_from_buffer(buffer):
    path,name = os.path.split(buffer.filename)
    name,ext = os.path.splitext(name)

    return name

def module_from_buffer(buffer):
    name = name_from_buffer(buffer)
    module = imp.new_module(name)
    
    update_from_dict(module,buffer.namespace)	

    return module
    
def import_buffer(buffer):
    name = name_from_buffer(buffer)
    
    if sys.modules.has_key(name):
    	update_from_dict(sys.modules[name], buffer.namespace)
    
    else:
    	sys.modules[name] = module_from_buffer(buffer)
	
def import_current():
    """For testing from within a PTUI buffer."""
    import_buffer(self.bufManager.current)




